# VE Edit Wasm Sdk

## 编译环境

```
emsdk : 2.0.3 upstream
```

## 目录结构
+ docs 接口文档
+ vesdk sdk 文件
  + -- sxedit.wasm
  + -- sxedit.js
  + -- sxedit.worker.js
  + -- utls 工具类库
+ demo 测试示例
  + -- demo.html 剪辑渲染示例
  + -- demo_template.html 模板渲染示例
  + -- js
  + -- css 
  + -- assets 供测试用的 模板,贴纸,转场,文字气泡等特效包

## 剪辑 sdk 使用步骤
---

## 参考 demo/demo.html 的 js 代码

## 使用简单示例

1. 添加好 canvas

```
<canvas id="canvas" width="272" height="480" ></canvas>
```

2. 引入 js 文件

```
<script src="/vesdk/sxedit.js" ></script>
<script>
    Module.onRuntimeInitialized = async _ => {
        printMsg("sx edit sdk loaded");
        // 在这里判断 sdk 加载初始化完成
    }

</script>
```


3. 调用 sdk 方法

```
// 1. 剪辑参数
var options = new SXEditOptions(license, 272, 480);

// 2. 创建剪辑管理器
editor = new SXEditManager(options, true, -1);

// 3. 获取主轨道
var mainTrack = editor.mainGroup();

// 4. 创建画中画轨道
var videoTrack = editor.createMediaTrack("/input.mp4", 0);
videoTrack.setPosition(new Module.Vec2(136,240));
videoTrack.setScale(new Module.Vec2(0.5,  0.5));

// 5. 添加到轨道组
var ret=  mainTrack.addTrack(videoTrack, 0);

// 6. 添加特效
var effectPath = "/path/to/video_effct";
var effect = videoTrack.addVideoEffect(effectPath);
effect.setDuration(5);

// 7. seek 和绘制指定时间点的画面
editor.seek(1.0); // seek 到 1.0 秒

// 绘制方法一
editor.draw(-1); // 绘制画面
editor.stepForward(); // 前进一帧
// 绘制方法二
editor.drawSync();

// 8. 使用完销毁
options.delete();
editor.delete();
```


4. 写入文件到浏览器缓存

在使用文件之前，请先写入文件到 FS 

https://emscripten.org/docs/api_reference/Filesystem-API.html#filesystem-api-filesystems

```       
 $("#select_file").change(function(){   
    var file = this.files[0];
    var reader = new FileReader();
    reader.readAsArrayBuffer(file);
    reader.onerror = function(e) {
        console.log(e);
    }
    reader.onload = function(e) {
        var targetFile = $("#target_file_name").val();;
        printMsg("add file : " + file.name+ " -> " + targetFile);
        FS.writeFile(targetFile, new Uint8Array(reader.result));
        console.log(FS.stat(targetFile));
    }
});      

```
