# 合成相关


---

## SXComposite

### getWidth() : number
```
   /**
     * 合成宽度
     * @return 宽度
     */
```

### getHeight() : number
```
    /**
     * 合成高度
     * @return 高度
     */
```

### getFps() : number
```
   /**
     * 合成帧率
     * @return 帧率
     */
```



#### getDuration() : number
```
  /**
     * 剪辑合成总时长
     * @return 时长单位为秒
     */
```

#### setDuration(duration : number) : void
```
   /**
     * 设置合成时长，时长会转换为对应的帧数保存
     * @param duration 时长，单位为秒
     */
```

#### getContentMaxTime(excludeAudio : bool) : number
```
    /**
     * 获取合成中轨道的最大结束时间
     * @param excludeAudio 是否排除音频时长
     * @return 轨道的最大结束时间
     */
```



####  addGroupAtIndex(index : number) : SXTrackGroup
```
    /**
     * 组是顺序存储的，因此可以在index所在的位置插入一个组
     * @param index 位置的索引，index超出数组个数或小于0时添加到末尾
     * @return 新组的实例对象
     */
```

#### deleteGroup(groupId : string) : void
```
  /**
     * 通过id删除组，如果组内存在轨道则会移除所有轨道，但不会删除轨道
     * @param id 组的唯一id
     */
```

#### getGroup(groupId : string) : SXTrackGroup
```
   /**
     * 通过id获取对应的组
     * @param id 组的uuid
     * @return 组的实例对象，不存在对应的组时返回nullptr
     */
```

#### moveGroupTo(groupId : string, index : number) : bool
```
    /**
     * 移动一个组到指定的位置
     * @param id 组的id
     * @param index 组新的位置
     * @return 组查找失败或索引越界返回false
     */
```

#### getGroups() : vector<SXTrackGroup *>
```
    /**
     * 获取所有的组，不包含主轨道
     * @return 顺序存储的所有组
     */
```

---

#### createMediaTrack(resource : SXResource, duration : number) : SXMediaTrack  
```
    /**
     * 创建媒体轨道，接受视频和图片素材
     * @param resource 资源
     * @param duration 时长
     * @return 失败返回null
     */
```

#### createStickerTrack(resource : SXResource, duration : number) : SXStickerTrack
```
    /**
     * 创建贴纸轨道
     * @param resource 资源
     * @param duration 时长
     * @return 失败返回null
```

#### createAudioTrack(resource : SXResource, duration : number) : SXAudioTrack
```
   /**
     * 创建媒体轨道，接受音频素材 
     * @param resource 资源
     * @param duration 时长
     * @return 失败返回null
     */
```

#### createTextTrack(duration : number) : SXTextTrack
```
   /**
     * 创建文字轨道
     * @param duration  持续时长，文字轨道必须指定时长
     * @return 失败返回null
     * */
```

####  deleteTrack(trackId : string) : void
```
    /**
     * 通过轨道id删除一个轨道
     * @param trackId 轨道id
     */
```

#### getTrack(trackId : string) : SXTrack
```
   /**
     *  根据指定 id 获取track
     *  @warning 音频轨道需要从音频管理器中获取
     *  @param trackId  轨道 ID
     *  @return 轨道对象实例
     * */
```

