# 剪辑管理器相关

## SXEditOptions

```
剪辑参数配置类
```

### 静态全局方法
通过 SXEditManager.XXX 调用

#### toMediaTrack(track :SXTrack) : SXMediaTrack
```    
   /**
    * 将 SXTrack 转成 SXMediaTrack
    *
    * @param track, SXTrack
    * @return SXMediaTrack
    * */
```

#### toStickerTrack(track :SXTrack) : SXStickerTrack
```
    /**
     * 将 SXTrack 转成 SXStickerTrack
     *
     * @param track, SXTrack
     * @return SXStickerTrack
     * */
```

#### toTextTrack(track :SXTrack) : SXTextTrack
```
    /**
     * 将 SXTrack 转成 SXTextTrack
     *
     * @param track, SXTrack
     * @return SXTextTrack
     * */
```

#### toAudioTrack(track :SXTrack) : SXAudioTrack
```
    /**
     * 将 SXTrack 转成 SXAudioTrack
     *
     * @param track, SXTrack
     * @return SXAudioTrack
     * */
```

### 方法

#### constructor(license : string, width : int, height: int)
```
license : 证书
width: 宽, px
height: 高, px
```

#### setFps(fps : number) : void
```
设置帧率，整型, 比如： 25， 30
@param fps
```

#### fps() : number
```
获取帧率
```

### setEnableSourceManager(enable : bool) : void
```
设置是否开启素材缓存

@param enable
```

### setSourceManagerCacheSize(size : number) : void
```
设置缓存池大小,默认  50 * 1024 * 1024

@param size 缓存池大小
```

### setCanvasId(canvasId : string) : void

```
设置 canvas id

@param canvasId
```

### setDefaultFontFile(fontPath : string) : void

```
设置默认字体路径

@param fontPath
```

#### delete() : void
```
释放对象
```

### 示例
```
let options = new SXEditOptions("", 136, 480);

options.delete();
```


---

## SXEditManager

```
剪辑管理器类，用于创建，管理轨道组和轨道，以及绘制相关操作
```

### 方法

#### constructor(optins: SXEditOptions, flip : bool)

```
构造函数

@param options : 参数
@param flip : 是否翻转画面, 传 true
@return SXEditManager

```


####  addGroupAtIndex(index : number) : SXTrackGroup
```
    /**
     * 组是顺序存储的，因此可以在index所在的位置插入一个组
     * @param index 位置的索引，index超出数组个数或小于0时添加到末尾
     * @return 新组的实例对象
     */
```

#### deleteGroup(groupId : string) : void
```
  /**
     * 通过id删除组，如果组内存在轨道则会移除所有轨道，但不会删除轨道
     * @param id 组的唯一id
     */
```

#### getGroup(groupId : string) : SXTrackGroup
```
   /**
     * 通过id获取对应的组
     * @param id 组的uuid
     * @return 组的实例对象，不存在对应的组时返回nullptr
     */
```

#### moveGroupTo(groupId : string, index : number) : bool
```
    /**
     * 移动一个组到指定的位置
     * @param id 组的id
     * @param index 组新的位置
     * @return 组查找失败或索引越界返回false
     */
```

#### getGroups() : vector<SXTrackGroup *>
```
    /**
     * 获取所有的组，不包含主轨道
     * @return 顺序存储的所有组
     */
```

---

#### createMediaTrack(resource : SXResource, duration : number) : SXMediaTrack  
```
    /**
     * 创建媒体轨道，接受视频和图片素材
     * @param resource 资源
     * @param duration 时长
     * @return 失败返回null
     */
```

#### createStickerTrack(resource : SXResource, duration : number) : SXStickerTrack
```
    /**
     * 创建贴纸轨道
     * @param resource 资源
     * @param duration 时长
     * @return 失败返回null
```

#### createAudioTrack(resource : SXResource, duration : number) : SXAudioTrack
```
   /**
     * 创建媒体轨道，接受音频素材 
     * @param resource 资源
     * @param duration 时长
     * @return 失败返回null
     */
```

#### createTextTrack(duration : number) : SXTextTrack
```
   /**
     * 创建文字轨道
     * @param duration  持续时长，文字轨道必须指定时长
     * @return 失败返回null
     * */
```

####  deleteTrack(trackId : string) : void
```
    /**
     * 通过轨道id删除一个轨道
     * @param trackId 轨道id
     */
```

#### cloneTrack(track: SXTrack) : SXTrack 
```
     /**
      * 复制 track
      *
      * @param SXTrack
      * @return SXTrack 
      */
```


#### getTrack(trackId : string) : SXTrack
```
   /**
     *  根据指定 id 获取track
     *  @warning 音频轨道需要从音频管理器中获取
     *  @param trackId  轨道 ID
     *  @return 轨道对象实例
     * */
```


#### createComposite(width : number, height : number, duration : number ) : SXComposite
```
  /**
     * 创建一个合成
     * @note 合成fps与options提供的fps一致
     * @param with 宽度
     * @param height 高度
     * @param frame 时长
     * @return 合成对象
     */
```

#### getComposite(compositeId : string) : SXComposite
```   
  /**
    * 通过id获取合成
    * @param id 合成id
    * @return 合成对象
    */

```

#### deleteComposite(compositeId : string) : void
``` 
    /**
     * 删除合成
     * @param id 合成id
     */

```

#### getDuration() : number
```
  /**
     * 剪辑合成总时长
     * @return 时长单位为秒
     */
```

#### setDuration(duration : number) : void
```
   /**
     * 设置合成时长，时长会转换为对应的帧数保存
     * @param duration 时长，单位为秒
     */
```

#### getContentMaxTime(excludeAudio : bool) : number
```
    /**
     * 获取合成中轨道的最大结束时间
     * @param excludeAudio 是否排除音频时长
     * @return 轨道的最大结束时间
     */
```


#### seek(time : number) : void
```
    /**
     * 设置当前的时间
     * @param time 时间，单位为秒
     * @return 时间在合成时间范围内时返回true，不在合成时间范围内时规范到合成时间范围内并返回false
     */
```

#### getCurrentTime() : number
```
   /**
     * 获取当前时间
     * */
```


#### draw(async : bool, stepForward : bool, callid : number) : void
```
   /**
     * 绘制画面
     * @param async, 是否异步绘制
     * @param stepForward, 是否自动前进一帧, 如果是播放时建议使用 true,
     * @param callid, 回调函数 id
     * */
```

#### setBackgroundColor(color : string) : void
```
    /**
     * 设置背景颜色
     *
     * @param color 背景颜色, eg: #RRGGBB
     * */
```

#### setDefaultFontFile(color : string) : void
```
    /**
     * 设置默认字体
     *
     * @param fontFile 默认字体路径
     * */
```


#### stepForward() : void
```
    /**
     * 前进一帧
     * @return 是否前进成功，到达结尾时则会返回false
     */
```

#### setCallback(type : SXCallbackType, callid : number ) : bool
```
    /**
    * 设置回调函数
    *
    * @param type
    * @param callid
    *
    */
```

#### getAudioManager() : SXAudioManager
```
    /**
     * 获取音频管理器
     *
     * */
```

#### toJson() : string 
```
     /**
      * 导出剪辑的 json 数据 
      *
      */
```


### 示例
```
var options = new SXEditOptions("license", 100, 100);
options.setCanvasId("canvas");

options.setEnableSourceManager(true);
options.setFps(30);

var editor = new SXEditManager(options, true);

options.delete();
editor.delete();
```

